#@ Double (label="First radius", value=25) yourRadius
#@ Double (label="Maximum Noise Threshold", value=7500) threshR
#@ Double (label="Low Threshold", value=200) lowTH
#@ Double (label="High Threshold", value=15000) highTH
//These are the values for everything. User can modify. Radius is the radius of the circle drawn around each maximum. threshR is the threshold for the find maxima. lowTH is the low bound of the histogram and highTH is the high bound of the histogram
dir2 = getDirectory("Choose output directory");
waitForUser("SELECT GFP IMAGE");
name = getTitle();
run("Z Project...", "projection=[Max Intensity]");
rename("myMAX");
setMinAndMax(lowTH, highTH);
for (m = 0; m < 3; m++){ 
	setTool("oval");
	waitForUser("Select background region");
	run("ROI Manager...");
	roiManager("Add");
		}
roiManager("measure");
selectWindow("Results");
saveAs(dir2+name+"_background.txt");	
selectWindow("ROI Manager");
run("Select All");
roiManager("delete");
run("Close");

run("Find Maxima...", "noise=threshR output=[Single Points] exclude");
rename("myMaxima");
run("Analyze Particles...", "display exclude clear include summarize add");
run("Clear Results");
selectWindow("myMAX");
roiManager("measure");
selectWindow("Results");
saveAs(dir2+name+"_maxima.txt");
mycount = roiManager("count");
for (m = 0; m < mycount; m++){ 
	selectWindow("myMAX");
	roiManager("Select", 0); 
	getSelectionCoordinates(x, y);
	makeRectangle(x[0] - yourRadius, y[0] - yourRadius, 2*yourRadius, 2*yourRadius);
	roiManager("Add");
	roiManager("Select", 0);
	roiManager("Delete");
}
mycount = roiManager("count");
for (m = 0; m < mycount; m++){
	selectWindow("myMAX");
	roiManager("Select", m); 
	run("Duplicate...","saveout");
	saveAs("Text image", dir2+name+"_"+m);
	run("Close");
}

run("Close All");
roiManager("Delete");
roiManager("Delete");
selectWindow("Results");
run("Clear Results");
